package com.dk.mdm.controller.mst;

import com.dk.common.model.pojo.PageList;
import com.dk.common.response.ResponseResultVO;
import com.dk.mdm.model.pojo.mst.Warehouse;
import com.dk.common.service.BaseService;
import com.dk.mdm.model.query.mst.WarehouseQuery;
import com.dk.mdm.model.response.mst.WarehouseResponse;
import com.dk.mdm.model.vo.mst.WarehouseVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import com.dk.mdm.service.mst.WarehouseService;

@Api(tags = "仓库档案API接口")
@RestController
@RequestMapping("/mst/warehouse")
public class WarehouseController{

    public BaseService<Warehouse> getService() {
        return warehouseService;
    }

    @Autowired
    private WarehouseService warehouseService;


    /**
     * @desc : 条件查询
     * @author : 于继渤
     * @date : 2024/2/26 10:36
     */
    @ApiOperation(value = "分页、关联、条件查询", notes = "分页、关联、条件查询")
    @PostMapping({"list_by"})
    public ResponseResultVO<PageList<WarehouseResponse>> selectByCond(@RequestBody WarehouseQuery warehouseQuery) {
        return warehouseService.selectByCond(warehouseQuery);
    }

    /**
     * @desc : 新建
     * @author : 于继渤
     * @date : 2023/1/5 9:39
     */
    @ApiOperation(value = "新建", notes = "新建")
    @PostMapping({"insert"})
    public ResponseResultVO<?> insert(@RequestBody WarehouseVO warehouseVO) {
        return warehouseService.insert(warehouseVO);
    }


    /**
     * @desc : 编辑
     * @author : 于继渤
     * @date : 2023/1/5 9:39
     */
    @ApiOperation( value = "编辑", notes = "编辑" )
    @PostMapping({"update"})
    public ResponseResultVO<?> update(@RequestBody WarehouseVO warehouseVO) {
        return warehouseService.update(warehouseVO);
    }



    /**
     * @desc : 停用
     * @author : 于继渤
     * @date :  2023/1/4 9:39
     */
    @PostMapping("disable/{id}")
    public ResponseResultVO<Boolean> disable(@PathVariable String id) {
        return this.getService().disable(id);
    }

    /**
     * @desc : 启用
     * @author : 于继渤
     * @date :  2023/1/4 9:39
     */
    @PostMapping("enable/{id}")
    public ResponseResultVO<Boolean> enable(@PathVariable String id) {
        return this.getService().enable(id);
    }


    /**
     * @desc : 批量编辑序号
     * @author : 于继渤
     * @date :  2023/1/4 9:39
     */
    @ApiOperation( value = "批量编辑序号", notes = "批量编辑序号" )
    @PostMapping({"update_batch_warehouse_display_no"})
    public ResponseResultVO<?> updateBatchWarehouseDisplayNo(@RequestBody WarehouseVO warehouseVO) {
        return warehouseService.updateBatchWarehouseDisplayNo(warehouseVO);
    }

}
